fun andConjs (f: CConj, g: CConj): CConj =
  case prjConj f of TrueConj => g | AndConj (f1,f2) => andConj (f1, andConjs (f2, g))
fun orDnfs (f: CDnf, g: CDnf): CDnf =
  case prjDnf f of FalseDnf => g | OrDnf (f1,f2) => orDnf (f1, orDnfs (f2, g))
fun andConjDnf (f: CConj, g: CDnf): CDnf =
  case prjDnf g of FalseDnf => falseDnf 
                 | OrDnf (g1, g2) => orDnf (andConjs (f, g1), andConjDnf (f, g2))
fun andDnfs (f: CDnf, g: CDnf): CDnf =
  case (prjDnf f, prjDnf g) of 
    (FalseDnf, _) => falseDnf
  | (_, FalseDnf) => falseDnf
  | (OrDnf (f1,f2), OrDnf (g1,g2)) => orDnf (andConjs (f1, g1),
                                      orDnfs (andConjDnf (f1, g2),
                                      orDnfs (andConjDnf (g1, f2),
                                              andDnfs (f2, g2))))
fun litToDnf (f: 'a ALit): CDnf = orDnf (andConj (f, trueConj), falseDnf)
fun toDnf (f: 'a AFmla): CDnf = let
  fun toDnf' (f: CFmla): CDnf =
    case mapFmla (prjFmla, id, id, id, id) (prjFmla f) of
      VarFmla s => litToDnf (varAtom s)
    | NotFmla (VarFmla s) => litToDnf (notLit (varAtom s))
    | NotFmla (NotFmla f) => toDnf' f
    | NotFmla TrueFmla => toDnf' falseFmla
    | NotFmla (AndFmla (f,g)) => toDnf' (orFmla (notFmla f, notFmla g))
    | NotFmla FalseFmla => toDnf' trueFmla
    | NotFmla (OrFmla (f,g)) => toDnf' (andFmla (notFmla f, notFmla g))
    | TrueFmla => orDnf (trueConj, falseDnf)
    | AndFmla (f,g) => andDnfs (toDnf' f, toDnf' g)
    | FalseFmla => falseDnf
    | OrFmla (f,g) => orDnfs (toDnf' f, toDnf' g)
in toDnf' (coerceFmla f) end