fun andConjs (f: CConj, g: CConj): CConj =
  caseConj f {True=fn () => g, And=fn (f1,f2) => andConj (f1, andConjs (f2, g))}
fun orDnfs (f: CDnf, g: CDnf): CDnf =
  caseDnf f {False=fn () => g, Or=fn (f1,f2) => orDnf (f1, orDnfs (f2, g))}
fun andConjDnf (f: CConj, g: CDnf): CDnf =
  caseDnf g {False=fn () => falseDnf, 
             Or=fn (g1,g2) => orDnf (andConjs (f, g1), andConjDnf (f, g2))}
fun andDnfs (f: CDnf, g: CDnf): CDnf =
  caseDnf f {False=fn () => falseDnf,
             Or=fn (f1,f2) => caseDnf g {False=fn () => falseDnf,
                                         Or=fn (g1,g2) => orDnf (andConjs (f1, g1),
                                                          orDnfs (andConjDnf (f1, g2),
                                                          orDnfs (andConjDnf (g1, f2),
                                                                  andDnfs (f2, g2))))}}
fun litToDnf (f: 'a ALit): CDnf = orDnf (andConj (f, trueConj), falseDnf)
fun toDnf (f: 'a AFmla): CDnf = let
  fun toDnf' (f: CFmla): CDnf =
    caseFmla f {Var=fn s => litToDnf (varAtom s),
                Not=fn f => caseFmla f {Var=fn s => litToDnf (notLit (varAtom s)),
                                        Not=fn f => toDnf' f,
                                        True=fn () => toDnf' falseFmla,
                                        And=fn (f,g) => toDnf' (orFmla (notFmla f, notFmla g)),
                                        False=fn () => toDnf' trueFmla,
                                        Or=fn (f,g) => toDnf' (andFmla (notFmla f, notFmla g))},
                True=fn () => orDnf (trueConj, falseDnf),
                And=fn (f,g) => andDnfs (toDnf' f, toDnf' g),
                False=fn () => falseDnf,
                Or=fn (f,g) => orDnfs (toDnf' f, toDnf' g)}
in toDnf' (coerceFmla f) end